/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialSeries } from "./FinancialSeries";
import { DependencyProperty } from "igniteui-angular-core";
import { ISortingAxis_$type } from "./ISortingAxis";
import { typeCast, markType, markDep } from "igniteui-angular-core";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-angular-core";
import { isNaN_ } from "igniteui-angular-core";
/**
 * @hidden
 */
export let FinancialOverlay = /*@__PURE__*/ (() => {
    class FinancialOverlay extends FinancialSeries {
        constructor() {
            super();
            this.aba = false;
            this.aba = false;
        }
        get_fa() {
            return true;
        }
        ph(a, b, c, d) {
            super.ph(a, b, c, d);
            if (this.xg != null && typeCast(ISortingAxis_$type, this.xg) !== null) {
                this.xg.i$i();
            }
            this.xx.cd.e(this.ie);
            this.abb();
            if (this.xz != null) {
                this.xz.d2();
            }
            this.ry(true);
        }
        get_he() {
            return true;
        }
        rg(a, b, c, d) {
            switch (b) {
                case "FastItemsSource":
                    this.aba = false;
                    break;
                case FinancialOverlay.$$p[0]:
                    this.aba = false;
                    this.ry(false);
                    this.qr();
                    break;
                case "XAxis":
                    this.aba = false;
                    break;
            }
            super.rg(a, b, c, d);
        }
        b3() {
            if (this.b4 == 0) {
                return 1;
            }
            else {
                return super.b3();
            }
        }
        gx(a, b) {
            if (this.gw(a, b)) {
                return true;
            }
            return false;
        }
        ac() {
            super.ac();
            this.ry(false);
        }
        ge(a) {
            let b = this.dp != null ? this.dp.indexOf(a) : -1;
            let c = this.cw.ca;
            c = c.copy();
            let d = this.cw.b9;
            let e = new Rect(0, 0, 0, 1, 1);
            let f = this.wv(this.cw);
            let g = new ScalerParams(0, e, e, this.xg.df, f);
            let h = new ScalerParams(0, e, e, this.xz.df, f);
            h.b = this.i0();
            if (b >= 0 && Rect.l_op_Inequality(c, null) && Rect.l_op_Inequality(d, null)) {
                if (this.xg != null) {
                    let i = this.xg.ft(b, g);
                    if (i < c.left + 0.1 * c.width) {
                        i = i + 0.4 * c.width;
                    }
                    if (i > c.right - 0.1 * c.width) {
                        i = i - 0.4 * c.width;
                    }
                    c.x = i - 0.5 * c.width;
                }
                if (this.xz != null && this.yb != null && this.ya != null && b < this.yb.count && b < this.ya.count) {
                    let j = this.xz.ft(this.yb.item(b), h);
                    let k = this.xz.ft(this.ya.item(b), h);
                    if (!isNaN_(j) && !isNaN_(k)) {
                        let l = Math.abs(j - k);
                        if (c.height < l) {
                            c.height = l;
                            c.y = Math.min(j, k);
                        }
                        else {
                            if (j < c.top + 0.1 * c.height) {
                                j = j + 0.4 * c.height;
                            }
                            if (j > c.bottom - 0.1 * c.height) {
                                j = j - 0.4 * c.height;
                            }
                            c.y = j - 0.5 * c.height;
                        }
                    }
                }
                this.c4.au(this.dc, c, true);
            }
            return b >= 0;
        }
        ay(a) {
            if (a != null && a == this.xz && this.yb != null && this.ya != null) {
                return new AxisRange(this.yb.minimum, this.ya.maximum);
            }
            return null;
        }
    }
    FinancialOverlay.$t = markType(FinancialOverlay, 'FinancialOverlay', FinancialSeries.$);
    FinancialOverlay.$$p = markDep(DependencyProperty, PropertyMetadata, FinancialOverlay, 'raisePropertyChanged', ['IgnoreFirst:abc:abe', [1, 0]]);
    return FinancialOverlay;
})();
